路口最短时间问题 - 华为OD统一考试

2024-01-28 15:04

本文主要是介绍路口最短时间问题 - 华为OD统一考试,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

OD统一考试(C卷)

分值: 200分

题解: Java / Python / C++

alt

题目描述

假定街道是棋盘型的,每格距离相等,车辆通过每格街道需要时间均为 timePerRoad;街道的街口(交叉点)有交通灯,灯的周期T(=lights[row][col])各不相同;

车辆可直行、左转和右转,其中直行和左转需要等相应T时间的交通灯才可通行,右转无需等待。

现给出 n*m 个街口的交通灯周期,以及起止街口的坐标,计算车辆经过两个街口的最短时间。

其中:

1)起点和终点的交通灯不计入时间,且可以任意方向经过街口
2)不可超出 n*m 个街口,不可跳跃,但边线也是道路(即 lights[0][0] -> lights[0][1] 是有效路径)

入口函数定义:

/**
* lights : n*m 个街口每个交通灯的周期,值范围[0,120],n和m的范围为[1,9]
* timePerRoad : 相邻两个街口之间街道的通过时间,范围为[0,600]
* rowStart : 起点的行号
* colStart : 起点的列号
* rowEnd : 终点的行号
* colEnd : 终点的列号
* return : lights[rowStart][colStart] 与 lights[rowEnd][colEnd] 两个街口之间的最短通行时间
*/
int calcTime(int[][] lights,int timePerRoad,int rowStart,int colStart,int rowEnd,int colEnd)

此题核心编程模式,实现对应方法即可。

示例1

输入:
[[1,2,3],[4,5,6],[7,8,9]],60,0,0,2,2输出:
245说明:
行走路线为(0,0)-> (0,1) -> (1,1) -> (1,2) ->(2,2)走了4格路,2个右转,1个左转,共耗时60+0+60+5+60+0+60=245

题解

数据量不大, 此题采用回溯法求解。

从四个方向到达起点,然后按照题目要求进行一步步的探索,直到所有的方案都探索完成,此时输出到达目标位置最短的时间。

Java

/*** @author code5bug*/
class Solution {private int[][] lights;private int timePerRoad;private int rowEnd, colEnd;private boolean[][][] vis;private int[][] directions = {{-1, 0}, {0, 1}, {1, 0}, {0, -1}};  // 上、右、下、左private int result;/*** lights : n*m 个街口每个交通灯的周期,值范围[0,120],n和m的范围为[1,9]* timePerRoad : 相邻两个街口之间街道的通过时间,范围为[0,600]* rowStart : 起点的行号* colStart : 起点的列号* rowEnd : 终点的行号* colEnd : 终点的列号* return : lights[rowStart][colStart] 与 lights[rowEnd][colEnd] 两个街口之间的最短通行时间*/public int calcTime(int[][] lights, int timePerRoad, int rowStart, int colStart, int rowEnd, int colEnd) {int n = lights.length, m = lights[0].length;this.lights = lights;this.timePerRoad = timePerRoad;this.rowEnd = rowEnd;this.colEnd = colEnd;this.result = Integer.MAX_VALUE;this.vis = new boolean[n][m][4];for (int d = 0; d < 4; d++) { // 从四个方向到达起点, 寻找到达目标位置路口最短的时间dfs(rowStart, colStart, d, 0);}return result != Integer.MAX_VALUE ? result : -1;}private boolean valid(int row, int col) {return 0 <= row && row < vis.length && 0 <= col && col < vis[0].length;}private void dfs(int row, int col, int direction, int time) {if (vis[row][col][direction] || time >= result) { // 剪枝: 已经遍历过 或 时间不会更短return;}// 到达终点if (row == rowEnd && col == colEnd) {result = Math.min(result, time);return;}vis[row][col][direction] = true;for (int d = -1; d <= 1; d++) {int newDir = (direction + d + 4) % 4;int dr = directions[newDir][0], dc = directions[newDir][1];int newRow = row + dc, newCol = col + dr;if (!valid(newRow, newCol)) continue;if (d == -1 || d == 0) { // 左转或直行dfs(newRow, newCol, newDir, time + timePerRoad + lights[row][col]);} else {  // 右转,不需要路口等待时间dfs(newRow, newCol, newDir, time + timePerRoad);}}vis[row][col][direction] = false;}
}

Python

from math import infclass Solution:# 返回通过指定路口之间的最短时间# @param lights int整型二维数组 n*m 个街口每个交通灯的周期,值范围[0,120],n和m的范围为[1,9]# @param timePerRoad int整型 相邻两个街口之间街道的通过时间,范围为[0,600]# @param rowStart int整型 起点的行号# @param colStart int整型 起点的列号# @param rowEnd int整型 终点的行号# @param colEnd int整型 终点的列号# @return int整型def calcTime(self, lights, timePerRoad, rowStart, colStart, rowEnd, colEnd):n, m = len(lights), len(lights[0])directions = [(-1, 0), (0, 1), (1, 0), (0, -1)]  # 上、右、下、左vis = [[[False] * 4] * m for _ in range(n)]def valid(row, col):return 0 <= row < n and 0 <= col < mdef dfs(row, col, direction, time):nonlocal resultif vis[row][col][direction] or time >= result:return# 到达终点if row == rowEnd and col == colEnd:result = min(result, time)returnvis[row][col][direction] = Truefor d in range(-1, 2, 1):new_dir = (direction + d + 4) % 4dr, dc = directions[new_dir]new_row, new_col = row + dc, col + drif not valid(new_row, new_col):continueif d == -1 or d == 0:  # 左转或直行dfs(new_row, new_col, new_dir, time +timePerRoad + lights[row][col])else:  # 右转dfs(new_row, new_col, new_dir, time + timePerRoad)vis[row][col][direction] = Falseresult = inffor d in range(4):dfs(rowStart, colStart, d, 0)return result if result != inf else -1

C++

class Solution {
private:vector<vector<int>> lights;int timePerRoad;int rowEnd, colEnd;vector<vector<vector<bool>>> vis;vector<vector<int>> directions = {{-1, 0}, {0, 1}, {1, 0}, {0, -1}}; // 上、右、下、左int result;public:int calcTime(vector<vector<int>>& lights, int timePerRoad, int rowStart, int colStart, int rowEnd, int colEnd) {int n = lights.size(), m = lights[0].size();this->lights = lights;this->timePerRoad = timePerRoad;this->rowEnd = rowEnd;this->colEnd = colEnd;this->result = INT_MAX;this->vis = vector<vector<vector<bool>>>(n, vector<vector<bool>>(m, vector<bool>(4, false)));for (int d = 0; d < 4; d++) {dfs(rowStart, colStart, d, 0);}return result != INT_MAX ? result : -1;}private:bool valid(int row, int col) {return 0 <= row && row < vis.size() && 0 <= col && col < vis[0].size();}void dfs(int row, int col, int direction, int time) {if (vis[row][col][direction] || time >= result) {return;}// 到达终点if (row == rowEnd && col == colEnd) {result = min(result, time);return;}vis[row][col][direction] = true;for (int d = -1; d <= 1; d++) {int newDir = (direction + d + 4) % 4;int dr = directions[newDir][0], dc = directions[newDir][1];int newRow = row + dc, newCol = col + dr;if (!valid(newRow, newCol)) {continue;}if (d == -1 || d == 0) { // 左转或直行dfs(newRow, newCol, newDir, time + timePerRoad + lights[row][col]);} else { // 右转,不需要路口等待时间dfs(newRow, newCol, newDir, time + timePerRoad);}}vis[row][col][direction] = false;}
};

‍❤️‍华为OD机试面试交流群每日真题分享): 加V时备注“华为od加群”

🙏整理题解不易, 如果有帮助到您,请给点个赞 ‍❤️‍ 和收藏 ⭐,让更多的人看到。🙏🙏🙏

这篇关于路口最短时间问题 - 华为OD统一考试的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/653985

相关文章

好题——hdu2522(小数问题:求1/n的第一个循环节)

好喜欢这题,第一次做小数问题,一开始真心没思路,然后参考了网上的一些资料。 知识点***********************************无限不循环小数即无理数,不能写作两整数之比*****************************(一开始没想到,小学没学好) 此题1/n肯定是一个有限循环小数,了解这些后就能做此题了。 按照除法的机制,用一个函数表示出来就可以了,代码如下

hdu1043(八数码问题,广搜 + hash(实现状态压缩) )

利用康拓展开将一个排列映射成一个自然数,然后就变成了普通的广搜题。 #include<iostream>#include<algorithm>#include<string>#include<stack>#include<queue>#include<map>#include<stdio.h>#include<stdlib.h>#include<ctype.h>#inclu

2024年流动式起重机司机证模拟考试题库及流动式起重机司机理论考试试题

题库来源:安全生产模拟考试一点通公众号小程序 2024年流动式起重机司机证模拟考试题库及流动式起重机司机理论考试试题是由安全生产模拟考试一点通提供,流动式起重机司机证模拟考试题库是根据流动式起重机司机最新版教材,流动式起重机司机大纲整理而成(含2024年流动式起重机司机证模拟考试题库及流动式起重机司机理论考试试题参考答案和部分工种参考解析),掌握本资料和学校方法,考试容易。流动式起重机司机考试技

购买磨轮平衡机时应该注意什么问题和技巧

在购买磨轮平衡机时,您应该注意以下几个关键点: 平衡精度 平衡精度是衡量平衡机性能的核心指标,直接影响到不平衡量的检测与校准的准确性,从而决定磨轮的振动和噪声水平。高精度的平衡机能显著减少振动和噪声,提高磨削加工的精度。 转速范围 宽广的转速范围意味着平衡机能够处理更多种类的磨轮,适应不同的工作条件和规格要求。 振动监测能力 振动监测能力是评估平衡机性能的重要因素。通过传感器实时监

hdu 2093 考试排名(sscanf)

模拟题。 直接从教程里拉解析。 因为表格里的数据格式不统一。有时候有"()",有时候又没有。而它也不会给我们提示。 这种情况下,就只能它它们统一看作字符串来处理了。现在就请出我们的主角sscanf()! sscanf 语法: #include int sscanf( const char *buffer, const char *format, ... ); 函数sscanf()和

缓存雪崩问题

缓存雪崩是缓存中大量key失效后当高并发到来时导致大量请求到数据库,瞬间耗尽数据库资源,导致数据库无法使用。 解决方案: 1、使用锁进行控制 2、对同一类型信息的key设置不同的过期时间 3、缓存预热 1. 什么是缓存雪崩 缓存雪崩是指在短时间内,大量缓存数据同时失效,导致所有请求直接涌向数据库,瞬间增加数据库的负载压力,可能导致数据库性能下降甚至崩溃。这种情况往往发生在缓存中大量 k

软考系统规划与管理师考试证书含金量高吗?

2024年软考系统规划与管理师考试报名时间节点: 报名时间:2024年上半年软考将于3月中旬陆续开始报名 考试时间:上半年5月25日到28日,下半年11月9日到12日 分数线:所有科目成绩均须达到45分以上(包括45分)方可通过考试 成绩查询:可在“中国计算机技术职业资格网”上查询软考成绩 出成绩时间:预计在11月左右 证书领取时间:一般在考试成绩公布后3~4个月,各地领取时间有所不同

6.1.数据结构-c/c++堆详解下篇(堆排序,TopK问题)

上篇:6.1.数据结构-c/c++模拟实现堆上篇(向下,上调整算法,建堆,增删数据)-CSDN博客 本章重点 1.使用堆来完成堆排序 2.使用堆解决TopK问题 目录 一.堆排序 1.1 思路 1.2 代码 1.3 简单测试 二.TopK问题 2.1 思路(求最小): 2.2 C语言代码(手写堆) 2.3 C++代码(使用优先级队列 priority_queue)

系统架构师考试学习笔记第三篇——架构设计高级知识(20)通信系统架构设计理论与实践

本章知识考点:         第20课时主要学习通信系统架构设计的理论和工作中的实践。根据新版考试大纲,本课时知识点会涉及案例分析题(25分),而在历年考试中,案例题对该部分内容的考查并不多,虽在综合知识选择题目中经常考查,但分值也不高。本课时内容侧重于对知识点的记忆和理解,按照以往的出题规律,通信系统架构设计基础知识点多来源于教材内的基础网络设备、网络架构和教材外最新时事热点技术。本课时知识

【VUE】跨域问题的概念,以及解决方法。

目录 1.跨域概念 2.解决方法 2.1 配置网络请求代理 2.2 使用@CrossOrigin 注解 2.3 通过配置文件实现跨域 2.4 添加 CorsWebFilter 来解决跨域问题 1.跨域概念 跨域问题是由于浏览器实施了同源策略,该策略要求请求的域名、协议和端口必须与提供资源的服务相同。如果不相同,则需要服务器显式地允许这种跨域请求。一般在springbo